#! /usr/bin/env python
# -*- coding: Latin-1 -*-

# Virtval simulation program
# (C) Grard Swinnen - Verviers, Belgium, 2003-2005
# last rev. 05/10/2005 - All rights reserved.

# Code source volontairement dstructur et d-document
# afin de contrarier le piratage. Veuillez contacter le
# distributeur du logiciel pour toute question relative
#  un dveloppement complmentaire ventuel.

from Tkinter import *
import tkMessageBox
from random import random, randrange
from math import pi, sin, cos
import Image, ImageDraw, ImageTk
import sys, os, os.path, time, gettext
import webbrowser
repDes =os.path.dirname(sys.argv[0])
if not os.path.isabs(repDes):
 repDes = os.getcwd() +"/" + repDes
os.chdir(repDes)
class Glob:
 nomProgVer ="VirtVal 1.09"
 lang ="fr"                                      # langue utilise
 cwd = os.getcwd()                              
 diaDir = os.path.join(cwd, "diatomees")         # rp. avec infos diatomes
 decoDir = os.path.join(cwd, "decors")           # rp. contenant les dcors
 cleDetDir = os.path.join(cwd, "clef_diatom/")   # rp. cl de dtermination
 transDir = os.path.join(cwd, "translations")    # rp. des traductions
 fontR ='Helvetica 8'
 fontM ='helvetica 10'
 fontS ='Helvetica 11'
 fontG ='Helvetica 10 bold'
 fontP ='Arial 12 bold italic'
 fontT ='Helvetica 14 bold'
 fontU ='Helvetica 16 bold'
 fontW ="Helvetica 20 bold"
 defBrowser ="firefox"           # commande de lancement du browser sous Linux
 diaFile = "diadata.txt"         # fichier contenant infos diatomes
 staFile = "stadata.txt"         # fichier contenant infos stations
 licFile = "virtval_license.txt" # texte de la licence
 diaDico ={}                    
 genDico ={}                    
 staDico ={}                    
 tysDico ={}                    
 micSize = 400                  
 showBTips =True                
 showTaxons =0                  
 showGrids =False               
 diaSelect1 =os.path.join(cleDetDir, "diaSelect1.gif")
 diaSelect2 =os.path.join(cleDetDir, "diaSelect2.gif")
 back_general ='vallee.gif'      # image de fond fentre principale
 back_oli ='bassin01.gif'        #
 back_mes ='bassin03.gif'        # images de fond des 3 bassins versants
 back_eu ='bassin02.gif'         #
 userFile = "user.txt"           # fichier utilisateur par dfaut
 grColor = ('white', '#FF9090', '#FFD080', 'yellow',
      'light green', 'light blue')
def buildStaAmeDico(cas, lecFile, staFile, tysFile):
  try:
   of = open(lecFile, "r")
  except:
   print "Fichier %s introuvable." % lecFile
   return
  lignes = of.readlines()    
  of.close()
  ligneSta =lignes[4]
  stations = ligneSta[:-1].split(";")
  print "****** Cas = %s ******" % (cas)
  col =2
  for sta in stations[3:]:   
   col += 1               
   if cas[:3] =='pat' and col ==15: continue
   if cas[:3] =='cul' and col ==24: continue
   sta = sta[1:-1]        
   nn =0
   print "Station",sta,"- colonne",col
   taxons =[]
   for ligne in lignes[5:]:  
    data =ligne[:-1].split(";")
    if data[0] =='': continue   # ignorer la dernire ligne
    taxL =data[0][1:-1]        
    taxL =taxL.split()         
    taxL =" ".join(taxL[:2])    # les rassocier en une chane
    ref =[]
    for r, i in Glob.diaDico.items():
     esp = i[0].split()     
     esp =" ".join(esp[:2])  # les rassocier en une chane
     if esp == taxL:        
      ref.append(r)
    if data[col]:
     nb = int(data[col])/5
     if len(ref) ==1:
      taxons.append((ref[0], nb))
     else:
      k =0 
      for u in range(nb):
       taxons.append((ref[k], 1))
       k = not k
   Glob.staDico[sta] =taxons
  sfi = open(staFile, "w")
  sfi.write("# %s - version du %s.\n" % (staFile, time.strftime("%d/%m/%y")))
  sfi.write("# Fichier construit par analyse automatique des tableaux Excel\n")
  sfi.write("# labors par Louis Leclercq.\n")
  sfi.write("# Ces donnes dcrivent les diatomes prsentes dans chaque type\n")
  sfi.write("# cologique de station de prlvement.\n")
  sfi.write("# Chaque enregistrement comporte la rf. d'une station,\n")
  sfi.write("# suivie d'une liste de couples (rf.taxon:nombre) - 20 couples max.\n\n")
  listeCas =Glob.staDico.items()
  listeCas.sort()
  for key, tuples in listeCas:
   txt = key +"|"
   for tu in tuples:
    txt = txt +str(tu[0]) +":" +str(tu[1]) +"_"
   sfi.write(txt[:-1] +"\n")
  sfi.close()
  ligneCod =lignes[2]
  codes = ligneCod[:-1].split(";")
  if cas[:3] =="pat": nstb =2
  else: nstb =3 
  col, ns, cc = 2, 0, 3      
  lsta =[]                   
  for sta in stations[3:]:   
   col += 1               
   if cas =="pati" and col >14 : continue
   if cas =="pate" and col <16: continue
   if cas =="culi" and col >23 : continue
   if cas =="cule" and col <25: continue
   sta = sta[1:-1]        
   lsta.append(sta)
   ns  += 1               
   if ns == nstb:
    cod = codes[cc][1:-1]  
    lc = cod.split()       
    if len(lc):
     for code in lc:
      Glob.tysDico[code] = lsta
    else:
     Glob.tysDico['def'] = lsta      # types naturels (dfaut)
    lsta = []
    ns = 0
    cc += nstb
  sfi = open(tysFile, "w")
  sfi.write("# %s - amnagements - version du %s.\n" %\
      (tysFile, time.strftime("%d/%m/%y")))
  sfi.write("# Fichier construit par analyse automatique du tableau Excel\n")
  sfi.write("# labor par Louis Leclercq.\n")
  sfi.write("# Ces donnes indiquent quels types de stations rsultent de la\n")
  sfi.write("# gologie et des amnagements effectus sur le territoire.\n")
  sfi.write("# Chaque enregistrement comporte un code amnagement, suivi\n")
  sfi.write("# de la liste des types  attribuer aux %s stations.\n\n" % (nstb))
  listeCas =Glob.tysDico.items()
  listeCas.sort()
  for key, liste in listeCas:
   txt = key +"|"
   for it in liste:
    txt = txt + it +";"
   sfi.write(txt[:-1] +"\n")
  sfi.close()
class BassinVerEu(Toplevel):
 def __init__(self, boss =None, backgr =None):
  Toplevel.__init__(self)
  self.title(_(" Bassin versant de type"))
  self.geometry("800x600")
  self.bind("<Configure>", self.redim)
  self.can =Canvas(self, scrollregion =(0, 0, 1024, 768))
  self.can.grid(row =0, column =0)
  self.can.bind("<Button-1>", self.clic)
  self.bdv = Scrollbar(self, orient =VERTICAL, command =self.can.yview)
  self.bdh = Scrollbar(self, orient =HORIZONTAL, command =self.can.xview)
  self.can.config(xscrollcommand =self.bdh.set,      
      yscrollcommand= self.bdv.set)
  self.bdv.grid(row =0, column =1, sticky = NS)      
  self.bdh.grid(row =1, column =0, sticky = EW)      
  im = Image.open(backgr)            
  self.imTk =ImageTk.PhotoImage(im)  
  self.can.create_image(0,0, anchor=NW, image =self.imTk)
  self.MenuBar()                  
 def redim(self, event):
  larg, haut = self.winfo_width()-20, self.winfo_height()-20
  self.can.config(width =larg, height =haut)
 def clic(self):
  pass
 def MenuBar(self):
  pass
class Determine(Toplevel):
 def __init__(self, boss =None):
  Toplevel.__init__(self)
  self.title(_(" Vue agrandie de l'individu slectionn"))
  self.boss = boss
  self.resizable(width =0, height =0)    
  sz = Glob.micSize/1.7
  self.can = Canvas(self, width =sz, height =sz, bg = 'white')
  self.can.pack(side =LEFT, padx =3, pady =3)
  self.afficheTexte()
  fraLB = Frame(self)
  Label(fraLB, text =_("De quel genre s'agit-il ?")).pack(pady =3)
  self.libox = Listbox(fraLB, height =12, width =20)
  scrol = Scrollbar(fraLB, command = self.libox.yview)
  self.libox.config(yscrollcommand =scrol.set)
  self.libox.pack(side =LEFT)
  self.libox.bind("<ButtonRelease-1>", self.sortie)
  scrol.pack(expand =YES, fill =Y)
  fraLB.pack(padx =3)
  lg = Glob.genDico.keys()       
  lg.sort()                      
  for nom in lg:
   self.libox.insert(END, nom)
  Button(self,text='OK',command =self.sortie).\
       pack(padx =3, pady=5, side=RIGHT)
  self.bind('<Destroy>',self.__kill__)    # si l'on referme la fentre
 def sortie(self, event =None):
  s = self.libox.curselection()          
  if len(s) ==0:
   self.boss.finDetermination(None)
   self.destroy()
   return
  nomSel = self.libox.get(s[0])          
  genDia = self.boss.dia.nom.split()[0]  
  if genDia != nomSel:                   
   self.boss.finDetermination("bad")
   self.destroy()
   return
  if Glob.genDico[nomSel] > 0:
   self.boss.finDetermination(nomSel) 
  else:
   Glob.genDico[nomSel] +=1
   self.boss.finDetermination("bad")
  self.destroy()
 def __kill__(self, event =None):
  self.boss.destroy_determ()     
 def mouseIn(self):
  self.choix =0
  self.libox.selection_clear('0',END)
  self.afficheTexte()
 def afficheTexte(self):
  sz = Glob.micSize/1.7
  box = (sz*2, sz*2)
  im = self.boss.dia.ima.resize(box, Image.ANTIALIAS)
  self.imTk = ImageTk.PhotoImage(im)
  self.can.delete(ALL)       
  self.can.create_image(sz/2, sz/2, anchor=CENTER, image =self.imTk)
  self.can.create_oval(-sz*.1 -5, -sz*.1, sz*1.11, sz*1.11,
        outline = 'black', width =sz/4)
 def test(self):
  print '***** test method in class Determine *****'
class Histogram(Toplevel):
 def __init__(self, boss, echant):
  Toplevel.__init__(self, borderwidth =2, relief =GROOVE)
  self.boss = boss
  self.ech = echant          
  self.ggr = 0               
  self.idl = ""               # indice diatomique Leclercq
  self.title(_(" Groupes de diatomes de la station S") + echant.numSta)
  self.resizable(width =0, height =0)    
  self.can = Canvas(self, width =340, height =340, bg = 'grey90')
  self.can.pack(padx=5, pady =5)
  self.bind("<Destroy>", self.__kill__)
  self.transient(master =boss)     
  self.refresh()
 def refresh(self):
  hist ={}           
  nt =0              
  avi = 0            
  avsvi =0           
  for dia in self.ech.diatoms:
   if not Glob.showTaxons and dia.reg ==0 : continue
   hist[dia.groupe] = hist.get(dia.groupe, 0) +1
   nt +=1
   avsvi += dia.vs * dia.vi
   avi += dia.vi
  if nt ==0:
   return  
  idl = avsvi / avi  
  ggr =1
  if idl > 2.25: ggr =2        
  if idl > 2.95: ggr =3        
  if idl > 3.55: ggr =4        
  if idl > 4.25: ggr =5
  self.can.delete(ALL)
  for gr in hist:
   x, h = gr*50, hist[gr]*15
   self.can.create_rectangle(x, 290 -h, x+45, 290,
           fill=Glob.grColor[gr])
   self.can.create_text(x +22, 305, text =str(gr))
   self.can.create_text(x +22, 275 -h,
         text =str(hist[gr]*100/nt)+ " %")
  self.can.create_rectangle(10,315,330,335, fill=Glob.grColor[ggr])
  self.can.create_text(170, 325, text =_("Total dt. =") +\
   " %s " % (nt) + _("Indice diatomique Leclercq =") + " %3.1f" % (idl))
  self.ggr =ggr              
  self.idl ="%2.1f" % idl
 def __kill__(self, evt =None):
  self.boss.destroy_histogr()    
class Observe(Toplevel):
 couleurs = (None, (220,100,150), (240,190,0), (210,210,0),
       (0,200,0), (100,150,200))
 def __init__(self, boss, echant):
  Toplevel.__init__(self)        
  self.boss =boss                
  self.ech = echant              
  self.title(_(" Observation des diatomes de la station S") + echant.numSta)
  self.selFlag =0                
  self.histogr = None            
  self.dia = None                
  self.resizable(width =0, height =0)   
  self.bind('<Destroy>', self.nettoyage)
  fraG =Frame(self)
  Label(fraG, text=_("Cliquez sur le centre de chaque diatome "+\
     "pour en dterminer le genre :"),
      wraplength =Glob.micSize).pack()
  self.can = Canvas(fraG, width =Glob.micSize, height =Glob.micSize,
        bg = 'white')
  self.can.pack()
  self.can.bind("<Button-1>", self.clic)
  Button(fraG, text =_("Cl de dtermination"), command =self.cleDet)\
              .pack(side =LEFT, padx =1)
  Button(fraG, text =_("Histogramme"), command =self.histogramme)\
              .pack(side =LEFT, padx =1)
  if Glob.showTaxons:
   Button(fraG, text =_("T"), command =self.showTaxons)\
              .pack(side =LEFT, padx =1)
  if Glob.micSize >400:
   Button(fraG, text =_("Recommencer"), command =self.restart)\
              .pack(side =RIGHT, padx =1)
  fraG.pack(side =LEFT)
  fraLB = Frame(self)
  Label(fraLB, text =_("De quel genre s'agit-il ?")).pack()
  haut =int(Glob.micSize/17.5)
  if haut >30: haut =30
  self.libox = Listbox(fraLB, width =18, height =haut)
  scrol = Scrollbar(fraLB, command = self.libox.yview)
  self.libox.config(yscrollcommand =scrol.set)
  self.libox.pack(side =LEFT)
  self.libox.bind("<ButtonRelease-1>", self.choixGenre)        
  scrol.pack(expand =YES, fill =Y)
  fraLB.pack(padx =3)
  lg = Glob.genDico.keys()       
  lg.sort()                      
  for nom in lg:
   self.libox.insert(END, nom)        
  self.Balloon()             
 def Balloon(self):
  pos =[]                    
  cc = int(Glob.micSize/2)   
  r_max = Glob.micSize*9/20  
  d_min = Glob.micSize/8     
  z =0                       
  for dia in self.ech.diatoms:
   while 1:
    angle = randrange(360)*2*pi/360
    rayon = randrange(r_max)
    x = int(rayon*cos(angle)) + cc
    y = int(rayon*sin(angle)) + cc
    w =0
    for p in pos:
     if x > p[0]-d_min and x < p[0]+d_min\
     and y > p[1]-d_min and y < p[1]+d_min:
      w =1           
    if w ==0 :
     pos.append((x,y))  
     break
   self.can.create_oval(x-2, y-2, x+2, y+2,               
      outline ='ivory', tags='D%s' % (z))
   self.can.create_image(x, y, anchor=CENTER, image =dia.imTk)
   z += 1
  sc = Glob.micSize
  self.mask =self.can.create_oval(-sc*.1 -5, -sc*.1, sc*1.11, sc*1.11,
        outline = 'black', width =sc/4)
 def montrerImage(self):
  self.can.itemconfigure(self.mask, outline='light grey')
  ps =self.can.postscript()
  ofi =open("drawing.ps", "w")
  ofi.write(ps)
  ofi.close()
  self.can.itemconfigure(self.mask, outline='black')
 def clic(self, event):
  if self.selFlag ==1:               
   self.dia.colorie(None)         
   self.libox.selection_clear('0',END)
  x = self.can.canvasx(event.x)
  y = self.can.canvasy(event.y)
  lit =self.can.find_enclosed(x-25, y-25, x+25, y+25)
  if len(lit) ==0:
   return                     
  it =lit[0]                     
  tags =self.can.gettags(it)     
  tag = tags[0]                  
  ind = int(tag[1:])             
  self.dia =self.ech.diatoms[ind]
  self.dia.colorie((200,0,240))  
  self.selFlag =1                
  genDia = self.dia.nom.split()[0]       
  if Glob.genDico[genDia] > 0:
   self.finDetermination(genDia)      
  else:
   self.APropos()       
   self.cleDet()              
 def APropos(self):
  sz = 500
  box1 = (sz, sz)                            
  box2 = (sz*5/16, sz/4, sz*11/16, sz*3/4)  
  infoListe = Glob.diaDico.values()
  infoListe.sort()
  flag =0               
  for info in infoListe:
   nom = info[0]                       
   if nom != self.dia.nom: continue   
   imFile = os.path.join(Glob.diaDir, info[3])
   try:
    im = Image.open(imFile)
   except:
    tkMessageBox.showerror(_(" Erreur"),
    _("Fichier") +" %s " % (imFile) + _("introuvable"))
    return
   try:
    pal = im.palette.getdata()[1]  
   except:
    pal = im.palette.data          
   im = im.resize(box1, Image.ANTIALIAS)
   im = im.crop(box2)
   im.putpalette(pal)         
   if flag ==0:
    im.save(Glob.diaSelect1)
    im = im.transpose(Image.FLIP_LEFT_RIGHT)
    im.save(Glob.diaSelect2)
    flag =1
   else:
    im.save(Glob.diaSelect2)
 def choixGenre(self, event =None):
  if self.dia ==None: return
  s = self.libox.curselection()          
  if len(s) ==0:
   return
  nomSel = self.libox.get(s[0])          
  genDia = self.dia.nom.split()[0]       
  if genDia != nomSel:                   
   tkMessageBox.showwarning(_(" Erreur"),
   _("Il s'agit d'un autre genre. Ressayez."))
   self.lift()
   return
  Glob.genDico[nomSel] +=1           
  self.finDetermination(nomSel)      
 def finDetermination(self, result):
  if result ==None:
   self.dia.colorie(None)     
  elif result =="bad":
   self.cleDet()              
   self.dia.colorie(None)     
  elif result =="ok":
   coul =self.couleurs[self.dia.groupe]
   for dia in self.ech.diatoms:
    if dia.nom == self.dia.nom:
     dia.colorie(coul)
  else:
   self.detEsp =creerBassinVer(self, result)
   self.dia.colorie(None)     
  self.selFlag =0                
 def restart(self):
  for dia in self.ech.diatoms:
   dia.colorie(None)
 def cleDet(self):
  htmFile = os.path.join(Glob.cleDetDir, 'clef01.htm')
  if sys.platform =='win32':
   webbrowser.open("file:%s" % htmFile)
  else:
   os.system(Glob.defBrowser +" "+ htmFile)
 def histogramme(self):
  if self.histogr == None:
   self.histogr = Histogram(self, self.ech)
  else:
   self.histogr.lift()        
   self.histogr.refresh()
  allDet =True
  for dia in self.ech.diatoms:
   if not dia.reg: allDet =False
  if allDet or Glob.showTaxons:        
   self.boss.centrer(self.ech.numSta, self.histogr.ggr,
          self.histogr.idl)
 def destroy_histogr(self):
  self.histogr = None
 def nettoyage(self, event =None):
  if self.histogr != None: self.histogr.destroy()
 def showTaxons(self):
  self.ech.contenu()
  for dia in self.ech.diatoms:
   coul =self.couleurs[dia.groupe]
   dia.colorie(coul)
class creerBassinVer(Toplevel):
 def __init__(self, boss =None, genre=None):
  Toplevel.__init__(self)
  self.title(_(" Espces faisant partie du genre ") + genre)
  self.boss = boss
  self.genre = genre
  Label(self, text =_("Cliquez sur le nom d'espce :")).\
     grid(row =0, column =0)
  self.can =Canvas(self, bg ="ivory", width =Glob.micSize,
       height = Glob.micSize, bd =2, relief =SUNKEN,
       scrollregion =(0, 0, Glob.micSize, Glob.micSize))
  self.can.grid(row =2, column =0)
  self.bdv = Scrollbar(self, orient =VERTICAL, command =self.can.yview)
  self.can.config(yscrollcommand= self.bdv.set)      
  self.bdv.grid(row =2, column =1, sticky = NS)      
  self.can.bind("<Button-1>", self.clic)
  self.aPropos()
  self.resizable(width =0, height =0)
 def aPropos(self):
  infoListe = Glob.diaDico.values()
  infoListe.sort()
  self.imTk = []     
  i =0               
  nomMem =''          # mmoris. du nom (pour montrer 2 faces si ncess.)
  box1 = (Glob.micSize, Glob.micSize)    
  size = Glob.micSize/5                  
  y = -size
  for info in infoListe:
   nom = info[0]                      
   genre = nom.split()[0]             
   espece = nom.split()[1]
   if genre != self.genre: continue   
   imFile = os.path.join(Glob.diaDir, info[3])
   try:
    ima = Image.open(imFile)
   except:
    tkMessageBox.showerror(_(" Erreur"),
    _("Fichier") +" %s " % (imFile) + _("introuvable"))
    return
   try:
    pal = ima.palette.getdata()[1]  
   except:
    pal = ima.palette.data          
   im = ima.resize(box1, Image.ANTIALIAS)
   im.putpalette(pal)         
   self.imTk.append(ImageTk.PhotoImage(im))
   if nom == nomMem:          
    x = x + size           
   else:
    x, y = size*.8, y + size*2.3
    self.can.create_text(size*2.5, y-20, text =nom, anchor=W,
        font ='Helvetica 14', tags =espece)
    comm = _("Indice de sensibilit =") +" %s" % (info[1])
    self.can.create_text(size*2.5, y, anchor=W, text =comm,
        font ='Helvetica 12')
    comm = _("Valeur indicatrice =") +" %s" % (info[2])
    self.can.create_text(size*2.5, y+15, anchor=W, text =comm,
        font ='Helvetica 12')
   nomMem = nom
   self.can.create_image(x, y, anchor=CENTER, image =self.imTk[i])
   i += 1
  self.can.config(scrollregion =(0, 0, Glob.micSize, y + size *1.5))
 def clic(self, event=None):
  x = self.can.canvasx(event.x)
  y = self.can.canvasy(event.y)
  lit =self.can.find_enclosed(x-200, y-40, x+200, y+40)
  if len(lit) ==0:
   return                     
  tags =self.can.gettags(lit[0]) 
  if len(tags) ==0:              
   return
  tag = tags[0]                  
  nomSel = self.boss.dia.nom.split()[1]      
  if tag == nomSel:
   tkMessageBox.showinfo(_(" Bravo !"),
   _("Votre dtermination est correcte.") + "\n" +\
   _("Tous les individus de cette espce vont tre automatiquement") +\
   "\n" + _("colors dans le champ d'observation microscopique."))
   self.boss.finDetermination("ok")
   self.boss.lift()
   self.destroy()
  else:
   tkMessageBox.showwarning(_(" Erreur"),
   _("Il s'agit d'une autre espce. Ressayez."))
   self.lift()
class showLicense:
 def __init__(self, infos):
  self.nom = infos[0]
  tailleDia = int(infos[4])      
  self.reg = 0                   
  self.vs, self.vi =float(infos[1]), int(infos[2])
  self.groupe =1
  if self.vs > 2.2: self.groupe =2        
  if self.vs > 2.9: self.groupe =3        
  if self.vs > 3.5: self.groupe =4        
  if self.vs > 4.2: self.groupe =5
  imFile = os.path.join(Glob.diaDir, infos[3])
  try:
   self.ima = Image.open(imFile)
  except:
   tkMessageBox.showerror(_(" Erreur"),
   _("Fichier") +" %s " % (imFile) + _("introuvable"))
   return
  aleat = 85 + randrange(30)     
  sizeD = tailleDia * Glob.micSize * aleat / 3000
  box1 = (sizeD, sizeD)          
  box2 = (sizeD/5, sizeD/5,      
    sizeD*4/5, sizeD*4/5)  
  try:
   pal = self.ima.palette.getdata()[1]  
  except:
   pal = self.ima.palette.data          
  self.im = self.ima.resize(box1, Image.ANTIALIAS)
  self.im.putpalette(pal)        
  im = self.im.rotate(randrange(360), Image.NEAREST)
  im = im.crop(box2)
  self.im.paste(im, box2)
  self.imTk = ImageTk.PhotoImage(self.im)
 def colorie(self, RGB):
  if RGB == None:                
   self.imTk.paste(self.im)   
   self.reg =0                
   return
  im = self.im.copy()            
  try:
   pal = im.palette.getdata()[1]  
  except:
   pal = im.palette.data          
  pal = pal + chr(0)*768         
  pal = pal[0:768]               
  lc = list(pal)                 
  for i in range(0,768,3):       
   n = ord(lc[i])                       
   lc[i] = chr(min(n/3 +RGB[0], 255))   
   n = ord(lc[i+1])
   lc[i+1] = chr(min(n/3 +RGB[1], 255)) 
   n = ord(lc[i+2])
   lc[i+2] = chr(min(n/3 +RGB[2], 255)) 
  pal = "".join(lc)               # re-conversion en une chane
  im.putpalette(pal)             
  self.imTk.paste(im)            
  self.reg =1                    
class montreDiato:
 def __init__(self, chimie =None, typBas =None, typSta =None, numSta=0):
  self.typBas = typBas     
  self.numSta = str(numSta)
  self.typSta = typSta       
  self.diatoms =[]           
  self.tracerImages()
 def tracerImages(self):
  taxons = Glob.staDico[self.typSta]     
  for tu in taxons:
   taxo, nbr = tu[0], tu[1]
   for n in range(nbr):
    d =showLicense(Glob.diaDico[taxo])
    self.diatoms.append(d)         
 def contenu(self):
  diTa ={}
  for d in self.diatoms:
   diTa[d.nom] =diTa.get(d.nom, 0) +1
  liTa =diTa.items()     
  liTa.sort()            
  ch =""                  # => chane pour l'affichage
  for ta, n in liTa:
   ch += "%s : %s %%\n" % (ta, n*5) 
  tkMessageBox.showinfo(_(" Taxons prsents dans l'chantillon :"), ch)
class traceCarte(Frame):
 def __init__(self, boss =None):
  Frame.__init__(self, borderwidth =0)
  self.boss =boss
  self.balloon =ChoixOptions(boss)
  fileMenu = Menubutton(self, text =_('Fichier'), bd =1, pady =0)
  fileMenu.pack(side =LEFT, padx =5)
  me1 = Menu(fileMenu)
  me1.add_command(label =_('Options'), underline =0,
      command = boss.creerDiaDico)
  me1.add_command(label =_('Organigramme'), underline =0,
      command = boss.splashWinClosed)
  me1.add_command(label =_('Terminer'), underline =0,
      command = boss.fermer)
  fileMenu.configure(menu = me1)
  self.actMenu = Menubutton(self, text =_('Amnagements  tester'),
        bd=1, pady =0)
  self.actMenu.pack(side =LEFT, padx =5)
  helpMenu = Menubutton(self, text =_('Aide'), bd =1, pady =0)
  helpMenu.pack(side =LEFT, padx =5)
  self.meH = Menu(helpMenu)
  self.meH.add_command(label =_('Principe'), underline =0,
      command = boss.SplashWindow)
  self.meH.add_command(label =_('A propos ...'), underline =0,
      command = boss.showIt)
  helpMenu.configure(menu = self.meH)
 def refresh(self, type=None):
  bassin =self.boss.bassin
  texts =[]      
  if type =='dis':
   me1 = Menu(self.actMenu)
   items =((_("Habitat sans station d'puration :"), 0,
        _("En l'absence de collecteur, les eaux uses sont rejetes en cours d'eau")+"\n"+\
        _("(pollution directe), ou via ruissellement (pollution diffuse).")+"\n"+\
        _("La pollution sera plus ou moins importante suivant le nombre d'habitants")+"\n"+\
        _("et l'loignement de l'habitat par rapport au cours d'eau rcepteur.")),
     (_('Installer un hameau (~150 hab.)'), bassin.hameau, ""),
     (_('Installer un village (~1200 hab.)'), bassin.village, ""),
     (_('Installer une ville (~15000 hab.)'), bassin.ville, ""),
     (_("puration des eaux uses :"), 0,
        _("Aprs construction d'un collecteur, les eaux uses arrivent toutes ")+"\n"+\
        _("la station d'puration.")),
     (_("Station d'puration primaire et secondaire"), bassin.step12,
        _("En puration primaire, on limine les particules lourdes (sable, ...)")+"\n"+\
        _("et les flottants (bouteilles en plastique ...). En puration secondaire,")+"\n"+\
        _("des bactries transforment les polluants organiques en nitrates et")+"\n"+\
        _("phosphates, dont une part importante est rejete dans le cours d'eau.")),
     (_("Station d'puration primaire, secondaire et tertiaire"), bassin.step123,
        _("En puration primaire, on limine les particules lourdes (sable, ...)")+"\n"+\
        _("et les flottants (bouteilles en plastique ...). En puration secondaire,")+"\n"+\
        _("des bactries transforment les polluants organiques en nitrates et")+"\n"+\
        _("phosphates, dont une part importante est assimile par des plantes,")+"\n"+\
        _("ce qui constitue l'puration tertiaire.")))
  elif type =="oli":
   me1 = Menu(self.actMenu)
   items =((_("levage intensif (avec amendements) :"), 0,
     _("D'importants pandages d'amendements organiques (fumier, lisier) et minraux")+"\n"+\
     _("(engrais chimiques) visent  produire plus d'herbe, et donc  augmenter la")+"\n"+\
     _("production animale (lait, viande). L'excs des pandages va aux cours d'eau")+"\n"+\
     _("en se rsorbant plus ou moins selon la distance parcourue.")),
     (_("Installer une petite pture (10% surf. disp.)"), bassin.elev_int_p, ""),
     (_("Installer une pture moyenne (45% surf. disp.)"), bassin.elev_int_m, ""),
     (_("Pturer toute la surface disponible"), bassin.elev_int_t, ""),
     (_("levage extensif ('bio') :"), 0,
     _("Les pandages sont limits : la production d'herbe est plus faible, et la")+"\n"+\
     _("vgtation est plus varie. On diminue alors le nombre de btes  l'hectare")+"\n"+\
     _("et on opte pour une production de qualit suprieure. Son impact sur la")+"\n"+\
     _("qualit de l'eau est ainsi trs rduit.")),
     (_("Installer une petite pture (10% surf. disp.)"), bassin.elev_ext_p, ""),
     (_("Installer une pture moyenne (45% surf. disp.)"), bassin.elev_ext_m, ""),
     (_("Pturer toute la surface disponible"), bassin.elev_ext_t, ""))
  elif type =="eu":
   me1 = Menu(self.actMenu)
   items =((_("Cultures intensives (avec amendements) :"), 0,
     _("Ce mode de culture vise  augmenter la production vgtale en utilisant")+"\n"+\
     _("beaucoup d'amendements et de pesticides, dont l'excs arrive plus ou moins")+"\n"+\
     _("vite au cours d'eau rcepteur.")),
     (_("Cultiver sur une petite surface (10% surf. tot.)"), bassin.cult_int_p, ""),
     (_("Cultiver une grande parcelle (45% surf. tot.)"), bassin.cult_int_m, ""),
     (_("Cultiver sur toute la surface disponible"), bassin.cult_int_t, ""),
     (_("Cultures extensives ('bio') :"), 0,
     _("Ce mode de culture vise des productions plus faibles mais de qualit,")+"\n"+\
     _("tout en utilisant peu d'amendements. Son impact est ainsi trs rduit.")),
     (_("Cultiver sur une petite surface (10% surf. tot.)"), bassin.cult_ext_p, ""),
     (_("Cultiver une grande parcelle (45% surf. tot.)"), bassin.cult_ext_m, ""),
     (_("Cultiver sur toute la surface disponible"), bassin.cult_ext_t, ""))
  elif type=="orga":
   self.actMenu.configure(state =DISABLED)
   self.meH.entryconfigure(1, command =self.boss.orga.SplashWindow)
   return
  else:
   self.actMenu.configure(state =DISABLED)
   self.meH.entryconfigure(1, command =self.boss.pano.SplashWindow)
   return
  for lab, comm, tip in items:
   if comm ==0:
    me1.add_command(label =lab, background ='grey90')
   else:
    me1.add_command(label =lab, command =comm)
   texts.append(tip)
  self.balloon.bind(me1, (270, 200), texts)
  self.actMenu.configure(menu = me1, state =NORMAL)
  self.meH.entryconfigure(1, command =bassin.SplashWindow)
class Dispo:
 def __init__(self, can, x, y, iFile=None, ref ="nn", type ="f"):
  self.can = can
  self.x, self.y = x, y
  self.iFile = iFile
  coulF= "yellow" # "#A0D000"         # vert jauntre
  if iFile:
   iFile = os.path.join(Glob.decoDir, iFile)
   self.image =PhotoImage(file =iFile)        
  self.ref = ref
  self.type = type       
  if type =="p":
   can.create_rectangle(x-80, y-80, x+80, y+80, fill =coulF,
         stipple ="gray25", width =0,
         tags =(ref, "mobile"))
  if type =="m":
   can.create_rectangle(x-160, y-160, x+160, y+160, fill =coulF,
         stipple ="gray25", width =0,
         tags =(ref, "mobile"))
  if type =="f" : tag =ref
  else: tag =(ref, "mobile")
  if iFile:
   self.id =can.create_image(x, y, image=self.image,
           tags =tag, anchor =CENTER)
 def BassinVerDis(self, dGrid, noeud):
  x, y = dGrid[noeud][0], dGrid[noeud][1]
  coo =self.can.coords(self.ref)
  if len(coo) ==4:
   xo =(coo[0]+coo[2])/2
   yo =(coo[1]+coo[3])/2
  else:
   xo, yo = coo[0], coo[1]
  dx, dy = x-xo, y-yo
  self.can.move(self.ref, dx, dy)
  self.can.itemconfigure(self.ref, tags =self.ref)
  self.x, self.y = x, y
  if self.type =="m" or self.type =="p":
   nx, ny = noeud /10, noeud %10
   for xx in range(nx-1, nx+2):
    for yy in range(ny-1, ny+2):
     nn = xx*10+yy
     if dGrid.has_key(nn):
      disp =dGrid[nn][2]
      if disp:
       if self.type =="m" or (xx==nx and yy==ny):
        iFile = os.path.join(Glob.decoDir, self.iFile)
       else:
        iFile = os.path.join(Glob.decoDir, "arbre_clair.gif")
       disp.image =PhotoImage(file =iFile)  
       self.can.itemconfigure(disp.id, image=disp.image)
  if "vil" not in self.iFile:     # sauf pour les habitats
   self.can.lift("t")
class prepImageHtml(Frame):
 def __init__(self):
  Frame.__init__(self)
  self.selObject =None
  self.can =Canvas(self, scrollregion =(0, 0, 1024, 768), bd =2, relief =SUNKEN)
  self.can.grid(row =0, column =0)
  self.bdv = Scrollbar(self, orient =VERTICAL, command =self.can.yview)
  self.bdh = Scrollbar(self, orient =HORIZONTAL, command =self.can.xview)
  self.can.config(xscrollcommand =self.bdh.set,      
      yscrollcommand= self.bdv.set)
  self.bdv.grid(row =0, column =1, sticky = NS)      
  self.bdh.grid(row =1, column =0, sticky = EW)      
  self.bind("<Configure>", self.redim)
  self.can.bind("<Button-1>", self.mouseDown)
  self.can.bind("<Button1-Motion>", self.mouseMove)
  self.can.bind("<Button1-ButtonRelease>", self.mouseUp)
  self.can.bind("<Button-3>", self.mouseRight)
  self.can.bind("<Button3-ButtonRelease>", self.mouseUp)
  self.dGrid ={}
  self.dispo =None       
  self.comment =None     
  self.typeActPrec =None 
  self.actEntam =False   
  self.actEffect =False  
  self.SEpresente =None  
  self.EchantEau()
  self.MenuBar()
  self.pack(expand =YES, fill =BOTH)
 def redim(self, event):
  larg, haut = self.winfo_width()-20, self.winfo_height()-20
  self.can.config(width =larg, height =haut)
 def mouseDown(self, event):
  x = self.x1 = self.x0 = self.can.canvasx(event.x)
  y = self.y1 = self.y0 = self.can.canvasy(event.y)
  self.act ='else'
  self.selObject =None
  c1 =self.can.find_enclosed(x-30, y-30, x+30, y+30)
  if len(c1) >0:                
   c2 =[]         
   for id in c1:
    c3 = self.can.gettags(id)  
    for tag in c3: 
     c2.append(tag)    
   if 'sta' in c2:
    self.act ='station'
  else:
   c1 =self.can.find_closest(self.x1, self.y1)
   if len(c1) ==0: return     
   c2 =self.can.gettags(c1)   
  if "mobile" in c2:
   self.selObject = c2[0]     
   self.act ='move' 
   self.can.lift(self.selObject)
  elif self.act =='station':
   for t in c2:
    if t[0] =="S": numSta = int(t[1:])
   typSta = self.typeSta[numSta -1]
   ech = montreDiato(typBas =self.type, typSta =typSta, numSta =numSta)
   if len(ech.diatoms) >0:
    Observe(self, ech)        
 def mouseMove(self, event):
  if self.selObject:
   x2, y2 = self.can.canvasx(event.x), self.can.canvasy(event.y)
   if self.act =='move':
    dx, dy = x2 -self.x1, y2 -self.y1
    self.can.move(self.selObject, dx, dy)    
    self.x1, self.y1 = x2, y2
 def mouseRight(self, event):
  pass
 def mouseUp(self, event):
  if self.selObject and self.act =='move':
   x = self.can.canvasx(event.x)
   y = self.can.canvasy(event.y)
   coo =self.can.coords(self.selObject)
   if len(coo) ==4:
    xo =(coo[0] +coo[2])/2
    yo =(coo[1] +coo[3])/2
   else:
    xo, yo = coo[0], coo[1]
   dx, dy = self.xIni -xo, self.yIni -yo
   for noeud, item in self.dGrid.items():
    if abs(x-item[0]) <40 and abs(y-item[1]) <40:
     if noeud in self.rnat:
      tkMessageBox.showwarning(_(" Interdit !"),
      _("Vous ne pouvez pas dvelopper cette activit dans "+\
      "la rserve naturelle."))
      break
     amNoeud =self.dispo.type + str(noeud)
     if not amNoeud in self.tysDico.keys():
      break
     item[2] =self.dispo
     self.dispo =noeud
     item[2].BassinVerDis(self.dGrid, noeud)
     self.actEffect =True
     self.EchantEau()
     self.selObject =None         
     self.actEntam =False         
     return
   self.can.move(self.selObject, dx, dy)
   self.x1, self.y1 = self.xIni, self.yIni
   self.selObject =None         
 def centrer(self, numSta, grp, idl):
  colors =("black","red","orange","yellow","green","blue")
  tag ="S%s" % (numSta)
  self.can.itemconfigure(tag, fill =colors[grp])
  tag ="Z%s" % (numSta)
  self.can.itemconfigure(tag, text =idl)
 def Diatomee(self):
  for i, x, y in self.stations:
   tag ="Z%s" % (i)
   self.can.itemconfigure(tag, text ="")
   tag ="S%s" % (i)
   self.can.itemconfigure(tag, fill ="grey60")
 def MenuBar(self):
  imFile = os.path.join(Glob.decoDir, self.fond)
  im = Image.open(imFile)            
  self.imTk =ImageTk.PhotoImage(im)  
  self.can.create_image(0,0, anchor=NW, image =self.imTk)
  self.grille()
  self.arbres()
  for i, x, y in self.stations:
   self.can.create_oval(x-12, y-12, x+12, y +12,
     fill = 'grey70', outline ="white", tags =('S%s' % (i), "t"))
   self.can.create_text(x, y, text ='S%s' % (i), tags =('sta','t'),
          anchor=CENTER)
   self.can.create_text(x, y -15, text ='', anchor =SE,
       fill ="white", font =Glob.fontG, tags =('Z%s' % (i),'t'))
 def arbres(self):
  for k in self.dGrid.keys():
   k1 = k/10
   k2 = k -k1*10
   if (k1+k2) %2 ==0: continue  
   iFile =("chene_hetre.gif",
     "bouleau_aulne.gif")[k in self.fondVal]
   x = self.dGrid[k][0] + randrange(20) -10
   y = self.dGrid[k][1] + randrange(20) -10
   self.dGrid[k][2] = Dispo(self.can, x, y, iFile,
          ref=("t", "a"), type="f")
 def grille(self):
  pass
 def EchantEau(self):
  code =0
  self.typeSta =[]                   
  for typ in self.tysDico['def']:     # types naturels par dfaut
   self.typeSta.append(typ)
  for k, v in self.dGrid.items():
   dis = v[2]                     
   if not dis: continue
   if dis.type =='f': continue     # ignorer les objets <fort>
   code = dis.type + str(k)
   if code in self.tysDico.keys():
    for n, typ in enumerate(self.tysDico[code]):
     self.typeSta[n] = typ
  if self.comment:
   self.can.itemconfigure(self.comment, text =\
   _("Vous pouvez  prsent cliquer sur\n") +\
   _("l'une ou l'autre station de prlvement\n") +\
   _("pour observer l'impact de cette activit\n") +\
   _("sur la qualit de l'eau."))
 def secWinDestroyed(self):
  for n in range(50):
   tag = "Dis" + str(n) 
   if tag in self.dicoD.keys(): continue
   else: return tag
  return None            
 def creerDispo(self, dTyp, iFile =None):
  if self.actEntam:
   tkMessageBox.showwarning(_(" Attention :"),
   _("Vous devez terminer l'action entreprise avant d'en choisir "+\
   "une autre."))
   return
  if self.actEffect:
   rep = tkMessageBox.askquestion(_(" Attention"),
    _("Une activit humaine a dj t programme, or vous ne "+\
    "pouvez en analyser qu'une seule  la fois.") + "\n\n"+\
    _("Souhaitez-vous annuler l'activit prcdente ?"))
   if rep in ("yes", True):
    k =self.dispo                  
    item = self.dGrid[k]           
    disp = item[2]                 
    x, y = disp.x, disp.y          
    self.can.delete("user")         # effacer les graph. associs
    iFile =("chene_hetre.gif",
      "bouleau_aulne.gif")[k in self.fondVal]
    nx, ny = k /10, k %10 
    if (nx+ny) %2 ==0:
     item[2] =None              
    else:  
     item[2] =Dispo(self.can, x, y, iFile, ref=("t","a"),
           type="f")
    self.dGrid[k] =item
    if self.SEpresente:
     self.can.delete("step")
     self.SEpresente =None
     self.creerTysDico("ame_hab_sans.txt")
    if self.typeActPrec =="g":
     del self.dGrid[k]          
     self.can.delete("full")     # effacer remplissage
     self.arbres()
    elif self.typeActPrec =='m' or self.typeActPrec =="p":
     iFile = os.path.join(Glob.decoDir, iFile)
     for xx in range(nx-1, nx+2):
      for yy in range(ny-1, ny+2):
       nn = xx*10+yy
       if self.dGrid.has_key(nn):
        disp =self.dGrid[nn][2]
        if disp:
         disp.image =PhotoImage(file =iFile)
         self.can.itemconfigure(disp.id,
                      image=disp.image)
    self.EchantEau()
    self.actEffect =False
    self.dispo =None
    self.Diatomee()
   return
  self.dispo = Dispo(self.can, self.xIni, self.yIni, iFile,
         ref="user", type =dTyp)
  self.typeActPrec =dTyp
  self.actEntam =True        
 def creerTysDico(self, tysFile):
  try:
   of = open(tysFile, "r")
  except:
   tkMessageBox.showerror(_(" Erreur"),
      _("Fichier") +" %s " % (tysFile) + _("introuvable"))
   return
  self.tysDico ={}   
  while 1:
   ligne = of.readline()
   if ligne == '': break       # fin du fichier
   data = ligne[:-1].split("|")
   if len(data) !=2:
    continue       
   code = data[0]     
   types = data[1].split(';')      # => liste des types de stations
   self.tysDico[code] =types                
  of.close()
 def expose_cas(self, cas):
  if Glob.lang != "fr":
   helpFile ="./translations/%s/help.txt" % Glob.lang
  else:
   helpFile ="help.txt"
  try:
   of = open(helpFile, "r")
  except:
   tkMessageBox.showerror(_(" Erreur"),
      _("Fichier d'aide introuvable"))
   return
  ll =of.readlines()
  of.close()
  t, txt = True, ""
  for li in ll:
   if li[:-1] == "[%s]" % (cas): t =False ; continue
   if t: continue
   if li[0] == "[": break
   txt += li
  msg =Toplevel(self)
  Message(msg, bg ="navy", fg ="ivory", width =700,
   font ="Helvetica 10 bold", text = txt).pack(padx =10, pady =10)
class creeDiato(prepImageHtml):
 def __init__(self, boss =None):
  self.fond = Glob.back_oli
  self.type ="oligo"
  self.stations =[(1,390,425),(2,790,680)]
  self.ban =(0,6,7,8,9,16,17,18,19,27,28,29,35,38,39,48,49,59,69,81,82,
     83,84,85,88,91,92,93,94,95,96,97) 
  self.fondVal =(12,13,14,21,22,23,24,25,31,32,33,34,35,36,45,46,47,
        56,57,67,68,78,88,98,99)
  self.rnat =()
  self.creerTysDico("ame_pat_int.txt")
  prepImageHtml.__init__(self)
  self.boss = boss
  self.master.title(_(" Valle des verts pturages"))
  self.totale =(400,35, 383,150, 393,300, 410,450, 368,570, 375,585,
     600,745, 905,760, 915,705, 815,580, 762,450, 705,350, 735,150,
     723,83, 710,67, 600,55, 500,35, 410,30)
  self.can.create_text(25, 500,
    text =_("Rserve ") +"\n" +_("forestire "), font =Glob.fontW,
    justify =LEFT,
    anchor =NW, fill="orange", tags ="fond")
  self.comment =self.can.create_text(25,630,
   text =_("D'aprs le plan de secteur,") +"\n" +\
      _("toute cette zone est dvolue") +"\n" +\
      _("aux activits d'levage ( l'exception") +"\n" +\
      _("de la rserve forestire)."), font=Glob.fontT,
   justify =LEFT,
   anchor =NW, fill="white", tags ="fond")
  self.xIni, self.yIni = 900, 100
 def grille(self):
  sX, sY, oX, oY = 80, 80, 150, 25
  for x in range(0,10):
   for y in range(1,10):
    xx, yy = oX + x*sX, oY + y*sY
    idNoeud= x*10 +y
    if idNoeud not in self.ban:
     if Glob.showGrids:
      self.can.create_text(xx, yy, text =str(idNoeud),
        anchor=CENTER, fill="grey", tags ="t")
     if x >=0 and x <10 and y>0:
      self.dGrid[idNoeud] =[xx, yy, None]
  limit =(400,20, 380,150, 390,300, 410,450, 350,600, 400,750)
  self.can.create_line(limit, width =5, stipple ="gray50",
        fill ="orange", smooth =1, tags ="f")
 def elev_int_t(self):
  self.creerTysDico("ame_pat_int.txt")
  self.envahir_surface("int")
  self.master.title(_("levage intensif sur toute la surface disponible"))
 def elev_ext_t(self):
  self.creerTysDico("ame_pat_ext.txt")
  self.envahir_surface("ext")
  self.master.title(_("levage extensif sur toute la surface disponible"))
 def envahir_surface(self, cas):
  self.creerDispo("g")
  if not self.dispo: return
  pol = self.can.create_polygon(self.totale, fill ="#A0D000", smooth =1,
        stipple ="gray25", tags="full")  
  for k, item in self.dGrid.items():
   disp = item[2]
   if not disp: continue
   if disp.type == "f":
    x, y = disp.x, disp.y
    if k /10 > 3:
     self.can.delete(disp.id)   
     if cas =="ext" and random() <.7:
      item[2] =None ; continue
     iFile = ("vache_petite.gif","vache_petite2.gif")[random() >.5]
     item[2] =Dispo(self.can, x, y, iFile, ref="t", type ="f")
  self.can.tag_raise("t", pol)
  self.dGrid[55]=[500,500, self.dispo]
  self.EchantEau()
  self.dispo =55             
  self.actEffect =True       
  self.actEntam =False         
 def elev_int_p(self):
  self.creerTysDico("ame_pat_int.txt")
  self.creerDispo("p", "vache_grande.gif")
  self.master.title(_("levage intensif sur une petite parcelle"))
 def elev_int_m(self):
  self.creerTysDico("ame_pat_int.txt")
  self.creerDispo("m", "vache_grande.gif")
  self.master.title(_("levage intensif sur la moiti "\
       "de la surface disponible"))
 def elev_ext_p(self):
  self.creerTysDico("ame_pat_ext.txt")
  self.creerDispo("p", "vache_petite.gif")
  self.master.title(_("levage extensif sur une petite parcelle"))
 def elev_ext_m(self):
  self.creerTysDico("ame_pat_ext.txt")
  self.creerDispo("m", "vache_petite.gif")
  self.master.title(_("levage extensif sur la moiti "\
       "de la surface disponible"))
 def SplashWindow(self):
  self.expose_cas("paturages")
class analyseAmenagements(prepImageHtml):
 def __init__(self, boss =None):
  self.fond = Glob.back_mes
  self.type ="dis"
  self.stations =[(1,545,395),(2,595,413),(3,454,707)]
  self.ban =(11,17,18,19,29,39,45,55,59,69,78,79,86,87,88,89,96,97,98,99) 
  self.rnat =(54,55,56,61,62,63,64,65,66,67,71,72,73,74,
     75,76,77,81,82,83,84,85,86,91,92,93,94,95)
  self.fondVal =(28,33,34,35,37,38,41,42,43,44,46,47,
        51,55,56,64,65,71,72,73,74,75,82,84,94)
  self.creerTysDico("ame_hab_sans.txt")
  prepImageHtml.__init__(self)
  self.boss = boss
  self.master.title(_(" Valle du beau sjour"))
  self.xIni, self.yIni = 100, 100
  self.can.create_text(995, 520,
    text =_(" Rserve") +"\n" +_(" naturelle"), font =Glob.fontW,
    justify =RIGHT,
    anchor =NE, fill="orange", tags ="fond")
  self.comment =self.can.create_text(25,650,
   text =_("D'aprs le plan de secteur,") +"\n" +\
      _("toute cette zone est dvolue") +"\n" +\
      _(" l'habitat ( l'exception de la") +"\n" +\
      _("rserve naturelle)."), font =Glob.fontT,
   justify =LEFT,
   anchor =NW, fill="white", tags ="fond")
 def grille(self):
  sX, sY, oX, oY = 78, 78, 240, 5
  for x in range(1,10):
   for y in range(1,10):
    xx, yy = oX + x*sX, oY + y*sY
    idNoeud= x*10 +y
    if Glob.showGrids and idNoeud not in self.ban:
     self.can.create_text(xx, yy, text =str(idNoeud),
        anchor=CENTER, fill="grey", tags ="grid")
    if x >0 and x <10 and y>0 and not idNoeud in self.ban:
     self.dGrid[idNoeud] =[xx, yy, None]
  limit =(725,20, 650,100, 680,230, 570,400, 700,600, 920,620)
  self.can.create_line(limit, width =5, stipple ="gray50",
        fill ="orange", smooth =1, tags ="fond")  
 def hameau(self):
  self.creerDispo("h","village.gif")
 def village(self):
  self.creerDispo("v","ville_moy.gif")
 def ville(self):
  self.creerDispo("u","ville_gde.gif")
 def step12(self):
  iFile ={"h":"petite","v":"moyenne","u":"grde"}[self.typeActPrec]
  self.ajouterSE("station_simple_%s.gif" % (iFile), "e2")
 def step123(self):
  iFile ={"h":"petite","v":"moyenne","u":"grde"}[self.typeActPrec]
  self.ajouterSE("station_double_%s.gif" % (iFile), "e3")
 def ajouterSE(self, iFile, typ):
  if self.SEpresente:
   rep = tkMessageBox.askquestion(_(" Attention"),
    _("Une station d'puration a dj t installe, or vous ne "+\
    "pouvez en ajouter qu'une seule  la fois.") + "\n\n"+\
    _("Souhaitez-vous supprimer la station existante ?"))
   if rep in ("yes", True):
    self.can.delete("step")
    self.creerTysDico("ame_hab_sans.txt")
    self.EchantEau()
    self.SEpresente =None
    self.Diatomee()
   return
  if not self.actEffect:
   tkMessageBox.showwarning(_(" Attention !"),
    _("Vous devez d'abord avoir install un hameau, "+\
       "un village ou une ville."))
   return
  for k, item in self.dGrid.items():
   disp =item[2]
   if not disp: continue
   if disp.type in ("h","v","u"):
    x, y = disp.x, disp.y
    if disp.type =="v": y += 80
    elif disp.type =="u": y += 120
    else: y += 50
    break
  iFile = os.path.join(Glob.decoDir, iFile)
  self.img =PhotoImage(file =iFile)
  self.can.create_image(x, y, image =self.img, tags ="step")
  self.Diatomee()
  if typ =="e2" : self.creerTysDico("ame_hab_se12.txt")
  else : self.creerTysDico("ame_hab_se123.txt")
  self.EchantEau()
  self.SEpresente =typ
 def SplashWindow(self):
  self.expose_cas("habitat")
class nouvSelection(prepImageHtml):
 def __init__(self, boss =None):
  self.fond = Glob.back_eu
  self.type ="eu"
  self.stations =[(1,342,443),(2,655,522),(3,893,600)]
  self.ban =(0,9,10,19,20,21,25,30,31,32,40,41,42,43,50,51,52,53,60,61,62,63,
     66,70,71,72,73,74,79,80,81,82,83,84,85,89,90,91,92,93,94,95,97,99) 
  self.fondVal =(3,5,14,16,23,36,47,56,58,67,76,87,98)
  self.rnat =(1,2,3,4,5,6,11,12,13,14,15,16,21,22,23,24)
  self.creerTysDico("ame_cul_int.txt")
  prepImageHtml.__init__(self)
  self.boss = boss
  self.master.title(_(" Valle de la fertilit"))
  self.totale =(367,200, 365,197, 390,290, 365,400, 275,525,
       123,580, 125,580, 220,755, 520,755, 820,740,
       1020,592, 1010,595, 750,410, 545,325)
  self.xIni, self.yIni = 900, 200
  self.can.create_text(25,195,
    text =_("Rserve ") +"\n" +_("forestire "), font =Glob.fontW,
    justify =LEFT,
    anchor =NW, fill="orange", tags ="fond")
  self.comment =self.can.create_text(980,25,
   text =_("D'aprs le plan de secteur,") +"\n" +\
      _("toute cette zone est dvolue") +"\n" +\
      _("aux cultures ( l'exception") +"\n" +\
      _("de la rserve forestire)."), font=Glob.fontT,
   justify =RIGHT,
   anchor =NE, fill="white", tags ="fond")
 def grille(self):
  sX, sY, oX, oY = 79, 79, 183, 47
  for x in range(0,11):
   for y in range(1,10):
    xx, yy = oX + x*sX, oY + y*sY
    idNoeud= x*10 +y
    if idNoeud in self.ban: continue
    if Glob.showGrids:
     self.can.create_text(xx, yy, text =str(idNoeud),
       anchor=CENTER, fill="grey", tags ="t")
    if x >=0 and x <10 and y>0:
     self.dGrid[idNoeud] =[xx, yy, None]
  limit =(390,15, 350,150, 400,300, 295,550, 30,600)
  self.can.create_line(limit, width =5, stipple ="gray50",
        fill ="orange", smooth =1, tags ="fond")
 def cult_int_t(self):
  self.creerTysDico("ame_cul_int.txt")
  self.envahir_surface("int")
  self.master.title(_("Cultures intensives sur toute la surface disponible"))
 def cult_ext_t(self):
  self.creerTysDico("ame_cul_ext.txt")
  self.envahir_surface("ext")
  self.master.title(_("Cultures extensives sur toute la surface disponible"))
 def envahir_surface(self, cas):
  self.creerDispo("g")
  if not self.dispo: return
  pol = self.can.create_polygon(self.totale, fill ="yellow", smooth =1,
        stipple ="gray25", tags="full")
  for noeud, item in self.dGrid.items():
   disp = item[2]
   if not disp: continue
   if disp.type == "f":
    x, y = disp.x, disp.y
    if noeud in self.rnat: continue
    self.can.delete(disp.id)   
    iFile ="ble03.gif"
    if cas =="ext":
     iFile = "ble_coquelicot.gif"
     if random() <.7:
      item[2] =None ; continue
    item[2] =Dispo(self.can, x, y, iFile, ref="t", type ="f")
  self.can.tag_raise("t", pol)
  self.dGrid[46]=[500,500, self.dispo]
  self.EchantEau()
  self.dispo =46             
  self.actEffect =True       
  self.actEntam =False         
 def cult_int_p(self):
  self.creerTysDico("ame_cul_int.txt")
  self.creerDispo("p", "ble03.gif")
  self.master.title(_("Culture intensive sur une petite parcelle"))
 def cult_ext_p(self):
  self.creerTysDico("ame_cul_ext.txt")
  self.creerDispo("p", "ble_coquelicot.gif")
  self.master.title(_("Culture extensive sur une petite parcelle"))
 def cult_int_m(self):
  self.creerTysDico("ame_cul_int.txt")
  self.creerDispo("m", "ble03.gif")
  self.master.title(_("Cultures intensives sur la moiti "\
       "de la surface disponible"))
 def cult_ext_m(self):
  self.creerTysDico("ame_cul_ext.txt")
  self.creerDispo("m", "ble_coquelicot.gif")
  self.master.title(_("Cultures extensives sur la moiti "\
       "de la surface disponible"))
 def SplashWindow(self):
  self.expose_cas("cultures")
class principe(prepImageHtml):
 def __init__(self, boss =None):
  prepImageHtml.__init__(self)
  self.boss = boss
  self.master.title(_(" La valle virtuelle"))        
 def EchantEau(self):
  pass       
 def MenuBar(self):
  imFile = os.path.join(Glob.decoDir, Glob.back_general)
  im = Image.open(imFile)            
  self.imTk =ImageTk.PhotoImage(im)  
  self.can.create_image(0,0, anchor=NW, image =self.imTk)
  icons =(('2', 320,220, 'oli'),
    ('1', 680,240, 'dis'),
    ('3', 300,610, 'eu'))
  u =0
  for i in icons:
   self.can.create_text(i[1],i[2], text =i[0], tags =i[3],
       font=Glob.fontW, anchor =CENTER, fill="white")
   u += 1
  return     
  self.can.create_text(350,100,
   text =_("Roches siliceuses") +"\n" +\
      _("Sols acides") +"\n" +\
      _("Eaux oligotrophes"), font=Glob.fontT,
   justify =RIGHT,
   anchor =NE, fill="white", tags ="oli")
  self.can.create_text(550,90,
   text =_("Roches siliceuses") +"\n" +\
      _("Sols acides") +"\n" +\
      _("Eaux oligotrophes"), font=Glob.fontT,
   justify =LEFT,
   anchor =NW, fill="white", tags ="dis")
  self.can.create_text(800,180,
   text =_("Roches siliceuses") +"\n" +\
      _("Sols trs acides") +"\n" +\
      _("Eaux dystrophes"), font=Glob.fontT,
   justify =LEFT,
   anchor =NW, fill="white", tags ="dis")
  self.can.create_text(150,480,
   text =_("Roches calcaires") +"\n" +\
      _("Sols basiques") +"\n" +\
      _("Eaux eutrophes"), font=Glob.fontT,
   justify =LEFT,
   anchor =NW, fill="white", tags ="eu")
 def Cadre_ext(self): 
  self.texte1 = self.can.create_text(512, 320, anchor =CENTER,
        font ="Helvetica 20 bold",
        text =_("Cliquez sur l'un des trois bassins versants"),
        fill = "orange")
  self.after(3000, self.effaceTexte) 
 def effaceTexte(self):
  self.can.delete(self.texte1)
 def mouseDown(self, event):
  x = self.can.canvasx(event.x)
  y = self.can.canvasy(event.y)
  lit =self.can.find_enclosed(x-200, y-200, x+200, y+200)
  if len(lit) ==0:
   return                     
  tags =self.can.gettags(lit[0]) 
  tag = tags[0]                  
  self.boss.MontrerEspeces(tag)
 def SplashWindow(self):
  self.expose_cas("panorama")
class Organigramme(prepImageHtml):
 def __init__(self, boss =None):
  prepImageHtml.__init__(self)
  self.boss = boss
  self.master.title(_(" La valle virtuelle"))        
 def EchantEau(self):
  pass       
 def MenuBar(self):
  if Glob.lang != "fr":
   imFile = os.path.join(Glob.transDir, Glob.lang) +"/organigra.gif"
  else:
   imFile = "organigra.gif"    #os.path.join(Glob.decoDir, Glob.organigra)
  im = Image.open(imFile)            
  self.imTk =ImageTk.PhotoImage(im)  
  self.can.create_image(512, 384, anchor=CENTER, image =self.imTk)
 def SplashWindow(self):
  msg =Toplevel(self)
  Message(msg, bg ="navy", fg ="ivory", width =400,
   font ="Helvetica 10 bold",
   text =_("Logiciel en cours de dveloppement.") +"\n\n" +\
   _("Vous trouverez des informations complmentaires sur le site :")+\
   "\nhttp://www.ulg.ac.be/cifen/inforef\n" +\
   _("Projet dvelopp en collaboration avec plusieurs partenaires europens."))\
   .pack(padx =10, pady =10)
 def mouseDown(self, event):
  self.boss.creerprincipe()
class colorieStation(Toplevel):
 def __init__(self, appli):
  Toplevel.__init__(self)    
  self.title(_(" Options"))
  self.resizable(width =0, height =0)    
  self.geometry("+200+150")
  self.transient(master =appli)     
  self.protocol('WM_DELETE_WINDOW', self.sortie)
  self.appli =appli
  Label(self, text=_("Prfrences, actions d'ensemble")).pack(pady =5)
  self.showBTips =IntVar()
  self.showBTips.set(Glob.showBTips)
  Checkbutton(self, text=_("Afficher des bulles d'aide dans les menus"),
     variable =self.showBTips,
     command =self.Application).pack(anchor =W, padx =10)
  self.showTaxons =IntVar()
  self.showTaxons.set(Glob.showTaxons)
  Checkbutton(self, text=_("Permettre la dtermination automatique"),
     variable =self.showTaxons,
     command =self.Application).pack(anchor =W, padx =10)
  self.showGrids =IntVar()
  self.showGrids.set(Glob.showGrids)
  Checkbutton(self, text=_("Afficher les grilles-repres"),
     variable =self.showGrids,
     command =self.Application).pack(anchor =W, padx =10)
  Label(self).pack()     
  Label(self, text =_("Taille du champ d'observation microscopique :")).\
    pack(padx =6)
  self.champMic =Entry(self, width =10)
  self.champMic.pack()
  Button(self,text =_("Quitter VirtVal"),
      command =self.quitter, width =20).\
      pack(side =LEFT, padx =5)
  Button(self,text ='OK', width =4, command =self.sortie).\
      pack(side =RIGHT, padx =5, pady =5)
  self.champMic.insert(END, str(Glob.micSize))
 def Application(self):
  pass
 def sortie(self, evt =None):
  s = int(self.champMic.get())
  if s < 300: s =300
  if s > 700: s =700
  Glob.micSize =s
  Glob.showTaxons = self.showTaxons.get()
  Glob.showGrids = self.showGrids.get()
  Glob.showBTips = self.showBTips.get()
  self.destroy()
 def quitter(self):
  self.appli.destroy()
class options(Toplevel):
 def __init__(self, boss, scrX, scrY):
  Toplevel.__init__(self)
  self.boss = boss
  larg, haut = 600, 410
  self.geometry("+%s+%s" % (scrX/2-larg/2, scrY/2-haut/2))
  self.overrideredirect(1)       
  self.transient(boss)           
  can = Canvas(self, width =larg, height =haut, bg='steel blue',
      bd =2, relief =RAISED)
  imFile = os.path.join(Glob.decoDir, "village.jpg")
  im = Image.open(imFile)            
  self.imTk1 =ImageTk.PhotoImage(im)  
  can.create_image(larg/2, 80, anchor=N, image =self.imTk1)
  imFile = os.path.join(Glob.decoDir,"cocci2.gif")
  self.imTk2 =PhotoImage(file =imFile)
  can.create_image(45, haut -45, anchor=SW, image =self.imTk2)
  imFile = os.path.join(Glob.decoDir,"logo_inforef_long.gif")
  self.imTk3 =PhotoImage(file =imFile)
  can.create_image(larg -45, haut -45, anchor=SE, image =self.imTk3)
  can.create_text(larg/2, 40, anchor =CENTER,
        font ="Arial 32 bold",
        text =_("La valle virtuelle"), fill = "white")
  can.create_text(larg/2, haut-15, anchor =CENTER, font ="Arial 8",
        text ="(C) 7P Soft & Inforef A.S.B.L. - Lige, " +\
           "Belgium 2003-2005 - All rights reserved.")
  can.pack(padx =0)
  self.bind("<Button-1>", self.quit)
 def timer(self, duree):
  self.after(duree, self.quit)
 def quit(self, event=None):
  self.destroy()
  self.boss.newDispId()
class copyToPostscript(Toplevel):
 def __init__(self, appli):
  Toplevel.__init__(self)    
  self.title(_("  propos de ") + Glob.nomProgVer)
  self.resizable(width =0, height =0)    
  self.transient(master =appli)     
  self.protocol('WM_DELETE_WINDOW', self.sortie)
  self.appli =appli
  Label(self).pack()     
  self.ima = PhotoImage(file =os.path.join(Glob.decoDir, "cocci2.gif"))
  fra = Frame(self, bd =2, relief =GROOVE)
  Label(fra, image =self.ima).pack(pady =2)
  Label(fra, text = Glob.nomProgVer + " : " +\
    _("La valle virtuelle"), font =Glob.fontP,
    fg ='navy', width =30).pack(pady =2)
  fra.pack(pady =5)        
  Label(self, text =_("Auteurs :") +" Grard Swinnen, Louis Leclercq & al."+\
   "\n\n(C) Inforef A.S.B.L., Lige 2003-2005.\n"+\
   "http://www.ulg.ac.be/cifen/inforef",
   font =Glob.fontG).pack(padx =10, pady =10)
  Label(self, text =_("Programme entirement dvelopp avec Python 2.3") +\
     "\n" + _("Utilise les bibliothques graphiques Tkinter & PIL") + "\n" +\
     _("( Voir : ") +"http://www.python.org\n& http://www.pythonware.com)",
     font =Glob.fontM).pack(padx =25, pady =4)
  try:    
   ofi =open(Glob.licFile, 'r')
   self.licenceText =ofi.read()
   ofi.close()
  except:
   tkMessageBox.showerror(_(" Erreur"),
   _("Fichier") +" %s " % (Glob.licFile) + _("introuvable."))
   self.licenseText =""
  self.bouLi = Button(self, text =_("Licence associe au logiciel"),
      command =self.Fenetre_ext)
  self.bouLi.pack(pady =9)
 def Fenetre_ext(self):
  fra =Frame(self)
  txt =Text(fra, width =50, height =10, padx =4)
  scr =Scrollbar(fra, command =txt.yview)
  txt.configure(yscrollcommand =scr.set)
  txt.pack(side =LEFT)
  scr.pack(side =RIGHT, fill=Y)
  txt.insert(END, self.licenceText)
  fra.pack(padx =5, pady =5)
  self.bouLi.configure(state =DISABLED)
 def sortie(self, evt =None):
  self.appli.creerStaDico()
  self.destroy()
class ChoixOptions:
 def __init__(self, boss):
  self.boss =boss        
  self.fen =None         
  self.status =0         
  self.texts =None
  self.ind =None
 def restaurerStations(self, evt, pos, texts):
  if self.status in (1, 2): return    
  geo = self.boss.geometry().split('+')
  xW, yW = int(geo[1]), int(geo[2])          
  self.x, self.y = xW +pos[0], yW +pos[1]    
  if type(texts) == type([]):
   self.texts =texts
   return
  txt =unicode(texts)
  if self.status ==0:
   self.status =1                         
   self.boss.after(1000, self.styleChange(txt))
  elif self.status ==3:                      
   self.status =1
   self.styleChange(txt)  
 def mouseMove(self, evt):
  if type(self.texts) != type([]): return
  if self.status ==1: return
  if sys.platform =="win32": oy =0 ; dy =19
  else: oy =18 ; dy =22
  ind = (evt.y -oy)/dy
  if ind ==self.ind: return
  if ind <0 or ind >= len(self.texts): return
  if self.status ==2: self.quit(); return
  self.ind =ind
  txt =self.texts[ind]
  if self.status ==0:
   self.status =1                         
   self.boss.after(300, self.styleChange(txt))
  elif self.status ==3:                      
   self.status =1
   self.styleChange(txt)                           
 def styleChange(self, txt):
  if not Glob.showBTips: return      
  if not txt: self.status =0; return
  if self.status ==1:     
   self.fen = Toplevel(self.boss)
   self.fen.overrideredirect(1)       
   self.fen.geometry("+%s+%s" % (self.x, self.y))
   self.fen.transient(master =self.boss)          
   Label(self.fen, text =txt, bg='ivory', bd=0,
      justify =LEFT, font =Glob.fontG).pack(padx=5, pady =2)
   self.status =2                         
  else:
   self.status =0     
 def quit(self, evt=None):
  if self.fen:
   self.fen.destroy()
   self.fen =None
  self.status =0
  self.ind =None
 def bind(self, widget, pos, text):
  widget.bind("<Enter>",
   lambda event, a1=pos, a2=text: self.restaurerStations(event, a1, a2))
  widget.bind("<Leave>", self.mouseOut)
  widget.bind("<Motion>", self.mouseMove)
 def mouseOut(self, evt):
  if self.fen:
   self.fen.destroy()
   self.fen =None
  self.status =3     
  self.boss.after(2000, self.quit)
class BassinVerOli(Tk):
 def __init__(self):
  Tk.__init__(self)
  scrX, scrY = 1040, 800
  self.geometry("%sx%s+20+10" %(scrX,scrY))
  self.option_readfile('optionDB')
  self.bassin =None          
  self.secWinPresent =False  
  self.sw =options(self, scrX, scrY)
  self.sw.timer(8000)        
  self.collectLeclercqData()        
  self.remontrerOrganigramme()        
  self.mbar =traceCarte(self)
  self.mbar.pack(side =TOP, expand =NO, fill =X)
  self.Panorama()
 def creerOrganigramme(self):
  buildStaAmeDico("habi", "cashabitat4sans.txt", "sta_hab_sans.txt",
      "ame_hab_sans.txt")
  buildStaAmeDico("habi", "cashabitat4se12.txt", "sta_hab_se12.txt",
      "ame_hab_se12.txt")
  buildStaAmeDico("habi", "cashabitat4se123.txt", "sta_hab_se123.txt",
      "ame_hab_se123.txt")
  Glob.tysDico ={}       
  buildStaAmeDico("pati", "caspatures4.txt", "sta_pat_int.txt",
      "ame_pat_int.txt")
  buildStaAmeDico("pate", "caspatures4.txt", "sta_pat_ext.txt",
      "ame_pat_ext.txt")
  Glob.tysDico ={}       
  buildStaAmeDico("culi", "cascultures2.txt", "sta_cul_int.txt",
      "ame_cul_int.txt")
  buildStaAmeDico("cule", "cascultures2.txt", "sta_cul_ext.txt",
      "ame_cul_ext.txt")
  os.system("cp sta_cul_ext.txt stadata.txt")
 def Panorama(self):
  self.orga =Organigramme(self)
  self.mbar.refresh(type="orga")
 def splashWinClosed(self):
  if self.orga:
   return         
  if self.pano:
   self.pano.destroy()
   self.pano =None
  if self.bassin:
   self.bassin.destroy()
   self.bassin =None
  self.Panorama()
 def creerprincipe(self):
  if self.sw : return    
  if self.orga:    
   self.orga.destroy()
   self.orga =None
  self.pano =principe(self)
  self.pano.Cadre_ext()
  self.mbar.refresh()
 def MontrerEspeces(self, type):
  self.pano.destroy()
  self.pano =None
  if type =='oli':
   self.bassin = creeDiato(self)
  elif type =='dis':
   self.bassin = analyseAmenagements(self)
  elif type =='eu':
   self.bassin = nouvSelection(self)
  else:
   print _("Type de bassin erron !")
  self.mbar.refresh(type)
 def fermer(self):
  if self.bassin:
   self.bassin.destroy()
   self.bassin =None
   self.creerprincipe()
  elif self.pano:
   self.quit()
 def newDispId(self):
  self.sw = None
 def creerStaDico(self):
  self.secWinPresent =False
 def creerDiaDico(self):
  colorieStation(self)
 def reset(self):
  pass
 def SplashWindow(self):
  msg =Toplevel(self)
  Message(msg, bg ="navy", fg ="ivory", width =400,
   font ="Helvetica 10 bold",
   text =_("Logiciel en cours de dveloppement.") +"\n\n" +\
   _("Vous trouverez des informations complmentaires sur le site :")+\
   "\nhttp://www.ulg.ac.be/cifen/inforef\n" +\
   _("Projet dvelopp en collaboration avec plusieurs partenaires europens."))\
   .pack(padx =10, pady =10)
 def showIt(self):
  copyToPostscript(self)
  self.secWinPresent =True
 def collectLeclercqData(self):
  try:
   of = open(Glob.diaFile, "r")
   while 1:
    ligne = of.readline()
    if ligne == '': break
    data = ligne[:-1].split(",")
    if len(data) !=6:
     continue                
    for i in range(len(data)):
     data[i] = data[i].strip()    
    Glob.diaDico[data[0]] = data[1:] 
    nomg = data[1].split()[0]
    Glob.genDico[nomg] = Glob.genDico.get(nomg, 0)
   of.close()
  except:
   tkMessageBox.showerror(_(" Erreur"),
   _("Fichier") +" %s " % (Glob.diaFile) + _("introuvable ou illisible."))
   return
 def remontrerOrganigramme(self):
  try:
   of = open(Glob.staFile, "r")
  except:
   tkMessageBox.showerror(_(" Erreur"),
   _("Fichier") +" %s " % (Glob.staFile) + _("introuvable."))
   return
  while 1:
   ligne = of.readline()
   if ligne == '': break       # fin du fichier
   data = ligne[:-1].split("|")
   if len(data) !=2:
    continue       
   sta = data[0]
   taxons = data[1].split('_')         # => liste de couples taxon:nombre
   for i in range(len(taxons)):
    taxons[i] = taxons[i].strip()  
   liTax =[]      
   for it in taxons:
    dat = it.split(':')             # liste ["rf. taxon", "nombre"]
    liTax.append((dat[0], int(dat[1])))
   Glob.staDico[sta] =liTax                
  of.close()
if __name__ == '__main__':
 try:
  obf =open("language.ini", "r")
  ligne = obf.readline()
  obf.close()
  item =ligne.split('"')
  Glob.lang = item[1]
  t =gettext.translation("virtval", "./translations",
         languages =[Glob.lang])
  t.install()
 except:
  def _(chaine):
   return chaine
 root = BassinVerOli()
 root.mainloop()
